/*###############################################################################
# Linux Management Providers (LMP), Power Supply provider package
# Copyright (C) 2009 Shakhrom RUSTAMOV, TUIT <shahrombek@gmail.com>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by <Author(s)>, <Affiliation>, <Year>
###############################################################################*/

#ifndef OPENDRIM_COMPUTERSYSTEMPOWERSUPPLYACCESS_H_
#define OPENDRIM_COMPUTERSYSTEMPOWERSUPPLYACCESS_H_

#include "PowerSupply_Common.h"

#include "OpenDRIM_ComputerSystemPowerSupply.h"
#include "assocOpenDRIM_ComputerSystemPowerSupply.h"

int PowerSupply_OpenDRIM_ComputerSystemPowerSupply_load(const CMPIBroker* broker, string& errorMessage);

int PowerSupply_OpenDRIM_ComputerSystemPowerSupply_unload(string& errorMessage);

int PowerSupply_OpenDRIM_ComputerSystemPowerSupply_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_ComputerSystemPowerSupply>& instances, const char** properties, string& errorMessage, const string& discriminant);

int PowerSupply_OpenDRIM_ComputerSystemPowerSupply_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_ComputerSystemPowerSupply& instance, const char** properties, string& errorMessage);

int PowerSupply_OpenDRIM_ComputerSystemPowerSupply_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_ComputerSystemPowerSupply& newInstance, const OpenDRIM_ComputerSystemPowerSupply& oldInstance, const char** properties, string& errorMessage);

int PowerSupply_OpenDRIM_ComputerSystemPowerSupply_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_ComputerSystemPowerSupply& instance, string& errorMessage);

int PowerSupply_OpenDRIM_ComputerSystemPowerSupply_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_ComputerSystemPowerSupply& instance, string& errorMessage);

int PowerSupply_OpenDRIM_ComputerSystemPowerSupply_associatorPartComponentToGroupComponent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& PartComponent_instance, const char** properties, vector<Instance>& GroupComponent_associatedInstances, string& errorMessage, const string& discriminant);

int PowerSupply_OpenDRIM_ComputerSystemPowerSupply_associatorGroupComponentToPartComponent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& GroupComponent_instance, const char** properties, vector<Instance>& PartComponent_associatedInstances, string& errorMessage, const string& discriminant);

int PowerSupply_OpenDRIM_ComputerSystemPowerSupply_referencePartComponentToGroupComponent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& PartComponent_instance, const vector<Instance>& GroupComponent_instances, vector<OpenDRIM_ComputerSystemPowerSupply>& OpenDRIM_ComputerSystemPowerSupply_instances, const char** properties, string& errorMessage, const string& discriminant);

int PowerSupply_OpenDRIM_ComputerSystemPowerSupply_referenceGroupComponentToPartComponent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& GroupComponent_instance, const vector<Instance>& PartComponent_instances, vector<OpenDRIM_ComputerSystemPowerSupply>& OpenDRIM_ComputerSystemPowerSupply_instances, const char** properties, string& errorMessage, const string& discriminant);

int PowerSupply_OpenDRIM_ComputerSystemPowerSupply_populate(OpenDRIM_ComputerSystemPowerSupply& instance, string& errorMessage);

#endif /*OPENDRIM_COMPUTERSYSTEMPOWERSUPPLYACCESS_H_*/
