/*###############################################################################
# Linux Management Providers (LMP), Power Supply provider package
# Copyright (C) 2009 Shakhrom RUSTAMOV, TUIT <shahrombek@gmail.com>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by <Author(s)>, <Affiliation>, <Year>
###############################################################################*/

#include "cmpiOpenDRIM_MemberOfPowerSupplyCollection.h"

CMPIObjectPath* PowerSupply_OpenDRIM_MemberOfPowerSupplyCollection_toCMPIObjectPath(const CMPIBroker* broker, const OpenDRIM_MemberOfPowerSupplyCollection& instance) {
	_E_;
	Objectpath op(broker, OpenDRIM_MemberOfPowerSupplyCollection_classnames[0], OpenDRIM_MemberOfPowerSupplyCollection_NAMESPACE);

	if (!instance.Collection_isNULL)
		op.addKey("Collection", instance.Collection);

	if (!instance.Member_isNULL)
		op.addKey("Member", instance.Member);

	_L_;
	return op.getHdl();
}

CMPIInstance* PowerSupply_OpenDRIM_MemberOfPowerSupplyCollection_toCMPIInstance(const CMPIBroker* broker, const OpenDRIM_MemberOfPowerSupplyCollection& instance) {
	_E_;
	Objectpath op(broker, PowerSupply_OpenDRIM_MemberOfPowerSupplyCollection_toCMPIObjectPath(broker, instance));
	Instance ci(broker, op);

	_L_;
	return ci.getHdl();
}

void PowerSupply_OpenDRIM_MemberOfPowerSupplyCollection_toCPP(const CMPIBroker* broker, const CMPIObjectPath* ref, OpenDRIM_MemberOfPowerSupplyCollection& instance) {
	_E_;
	Objectpath op(broker, (CMPIObjectPath*) ref);

	if (op.getKey("Member", instance.Member) == OK)
		instance.Member_isNULL = false;

	if (op.getKey("Collection", instance.Collection) == OK)
		instance.Collection_isNULL = false;

	_L_;
}

void PowerSupply_OpenDRIM_MemberOfPowerSupplyCollection_toCPP(const CMPIBroker* broker, const CMPIInstance* ci, OpenDRIM_MemberOfPowerSupplyCollection& instance) {
	_E_;
	Instance inst(broker, (CMPIInstance*) ci);

	if (inst.getProperty("Collection", instance.Collection) == OK)
		instance.Collection_isNULL = false;

	if (inst.getProperty("Member", instance.Member) == OK)
		instance.Member_isNULL = false;

	_L_;
}

