/*###############################################################################
# Linux Management Providers (LMP), Power Supply provider package
# Copyright (C) 2009 Shakhrom RUSTAMOV, TUIT <shahrombek@gmail.com>
#
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
#
# Modified by <Author(s)>, <Affiliation>, <Year>
###############################################################################*/

#ifndef OPENDRIM_POWERSUPPLYREDUNDANCYSETACCESS_H_
#define OPENDRIM_POWERSUPPLYREDUNDANCYSETACCESS_H_

#include "PowerSupply_Common.h"

#include "OpenDRIM_PowerSupplyRedundancySet.h"

int PowerSupply_OpenDRIM_PowerSupplyRedundancySet_load(const CMPIBroker* broker, string& errorMessage);

int PowerSupply_OpenDRIM_PowerSupplyRedundancySet_unload(string& errorMessage);

int PowerSupply_OpenDRIM_PowerSupplyRedundancySet_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_PowerSupplyRedundancySet>& instances, const char** properties, string& errorMessage, const string& discriminant);

int PowerSupply_OpenDRIM_PowerSupplyRedundancySet_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_PowerSupplyRedundancySet& instance, const char** properties, string& errorMessage);

int PowerSupply_OpenDRIM_PowerSupplyRedundancySet_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_PowerSupplyRedundancySet& newInstance, const OpenDRIM_PowerSupplyRedundancySet& oldInstance, const char** properties, string& errorMessage);

int PowerSupply_OpenDRIM_PowerSupplyRedundancySet_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_PowerSupplyRedundancySet& instance, string& errorMessage);

int PowerSupply_OpenDRIM_PowerSupplyRedundancySet_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_PowerSupplyRedundancySet& instance, string& errorMessage);

int PowerSupply_OpenDRIM_PowerSupplyRedundancySet_Failover(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_PowerSupplyRedundancySet& instance, unsigned int& returnValue, const OpenDRIM_PowerSupplyRedundancySet_Failover_In& in, string& errorMessage);

int PowerSupply_OpenDRIM_PowerSupplyRedundancySet_populate(OpenDRIM_PowerSupplyRedundancySet& instance, string& errorMessage);

#endif /*OPENDRIM_POWERSUPPLYREDUNDANCYSETACCESS_H_*/
